#line 1 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/__secure2_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 120 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/__secure2_hal.h"
typedef void ( *T_SECURE2_I2C_Start )( char slave_address,
 char dir);
typedef void ( *T_SECURE2_I2C_Stop )();
typedef void ( *T_SECURE2_I2C_Restart )();
typedef unsigned char ( *T_SECURE2_I2C_Write )( unsigned char data_in,
 unsigned char mode);
typedef unsigned char ( *T_SECURE2_I2C_Read )( unsigned char *data_out,
 unsigned char mode);
#line 31 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
static T_SECURE2_I2C_Start fpStartI2C;
static T_SECURE2_I2C_Stop fpStopI2C;
static T_SECURE2_I2C_Restart fpRestartI2C;
static T_SECURE2_I2C_Write fpWriteI2C;
static T_SECURE2_I2C_Read fpReadI2C;

static int HAL_i2cStartWrite(uint8_t slaveAddress);
static int HAL_i2cWrite(uint8_t slaveAddress, uint8_t *pBuf, uint16_t nBytes, uint8_t endMode);
static int HAL_i2cStartRead(uint8_t slaveAddress);
static int HAL_i2cRead(uint8_t slaveAddress, uint8_t *pBuf, uint16_t nBytes, uint8_t endMode);
#line 152 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
static uint8_t startF = 0;
#line 200 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
static int HAL_i2cStart()
{
 int res = 0;









 startF = 1;
#line 232 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
 return res;
}
#line 259 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
static int HAL_i2cWrite(uint8_t slaveAddress, uint8_t *pBuf, uint16_t nBytes, uint8_t endMode)
{
 int res = 0;
 uint8_t *ptr = pBuf;
#line 276 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
 if( startF )
 {
 fpStartI2C(slaveAddress, _I2C_DIR_MASTER_TRANSMIT);
 Delay_1ms();
 startF = 0;
 }

 if(nBytes == 1)
 {
 res |= fpWriteI2C( *ptr, _I2C_MASTER_MODE_SINGLE_SEND );
 Delay_1ms();
 }
 else if(nBytes == 2)
 {
 res |= fpWriteI2C( *ptr++, _I2C_MASTER_MODE_BURST_SEND_START );
 Delay_1ms();
 res |= fpWriteI2C( *ptr, _I2C_MASTER_MODE_BURST_SEND_FINISH );
 }
 else
 {
 res |= fpWriteI2C( *ptr++, _I2C_MASTER_MODE_BURST_SEND_START );
 Delay_1ms();
 while(--nBytes > 1)
 {
 res |= fpWriteI2C( *ptr++, _I2C_MASTER_MODE_BURST_SEND_CONT );
 Delay_1ms();
 }
 res |= fpWriteI2C( *ptr, _I2C_MASTER_MODE_BURST_SEND_FINISH );
 }

 if( endMode =  1  )
 {
 startF = 1;
 }
#line 350 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
 return res;
}
#line 379 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
static int HAL_i2cRead(uint8_t slaveAddress, uint8_t *pBuf, uint16_t nBytes, uint8_t endMode)
{
 int res = 0;
 uint8_t *ptr = pBuf;
#line 396 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
 if( startF )
 {
 fpStartI2C(slaveAddress, _I2C_DIR_MASTER_RECEIVE);
 Delay_1ms();
 startF = 0;
 }

 if(nBytes == 1)
 {
 res |= fpReadI2C(ptr, _I2C_MASTER_MODE_SINGLE_RECEIVE);
 Delay_1ms();
 }
 else if(nBytes == 2)
 {
 res |= fpReadI2C(ptr++, _I2C_MASTER_MODE_BURST_RECEIVE_START);
 Delay_1ms();
 res |= fpReadI2C(ptr, _I2C_MASTER_MODE_BURST_RECEIVE_FINISH);
 }
 else
 {
 res |= fpReadI2C(ptr++ , _I2C_MASTER_MODE_BURST_RECEIVE_START);
 Delay_1ms();
 while(--nBytes > 1)
 {
 res |= fpReadI2C(ptr++ , _I2C_MASTER_MODE_BURST_RECEIVE_CONT);
 Delay_1ms();
 }
 res |= fpReadI2C(ptr, _I2C_MASTER_MODE_BURST_RECEIVE_FINISH);
 }
 if( endMode =  1  )
 {
 startF = 1;
 }
#line 472 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/__SECURE2_Hal.c"
 return res;
}
