_aes132c_calculate_crc:
;aes132_comm.c,33 :: 		void aes132c_calculate_crc(uint8_t length, uint8_t *data, uint8_t *crc)
; crc start address is: 8 (R2)
; data_ start address is: 4 (R1)
; length start address is: 0 (R0)
; crc end address is: 8 (R2)
; data_ end address is: 4 (R1)
; length end address is: 0 (R0)
; length start address is: 0 (R0)
; data_ start address is: 4 (R1)
; crc start address is: 8 (R2)
;aes132_comm.c,36 :: 		uint8_t crc_low = 0, crc_high = 0, crc_carry;
; crc_low start address is: 44 (R11)
MOVW	R11, #0
; crc_high start address is: 40 (R10)
MOVW	R10, #0
;aes132_comm.c,37 :: 		uint8_t poly_low = 0x05, poly_high = 0x80;
; poly_low start address is: 24 (R6)
MOVS	R6, #5
; poly_high start address is: 28 (R7)
MOVS	R7, #128
;aes132_comm.c,41 :: 		for (counter = 0; counter < length; counter++) {
; counter start address is: 32 (R8)
MOVW	R8, #0
; length end address is: 0 (R0)
; data_ end address is: 4 (R1)
; crc end address is: 8 (R2)
; poly_low end address is: 24 (R6)
; poly_high end address is: 28 (R7)
; crc_high end address is: 40 (R10)
; crc_low end address is: 44 (R11)
; counter end address is: 32 (R8)
L_aes132c_calculate_crc0:
; counter start address is: 32 (R8)
; poly_high start address is: 28 (R7)
; poly_low start address is: 24 (R6)
; crc_high start address is: 40 (R10)
; crc_low start address is: 44 (R11)
; crc start address is: 8 (R2)
; data_ start address is: 4 (R1)
; length start address is: 0 (R0)
CMP	R8, R0
IT	CS
BCS	L_aes132c_calculate_crc1
;aes132_comm.c,42 :: 		for (shift_register = 0x80; shift_register > 0x00; shift_register >>= 1) {
; shift_register start address is: 36 (R9)
MOVW	R9, #128
; length end address is: 0 (R0)
; data_ end address is: 4 (R1)
; crc end address is: 8 (R2)
; poly_low end address is: 24 (R6)
; poly_high end address is: 28 (R7)
; crc_high end address is: 40 (R10)
; crc_low end address is: 44 (R11)
; shift_register end address is: 36 (R9)
; counter end address is: 32 (R8)
L_aes132c_calculate_crc3:
; shift_register start address is: 36 (R9)
; length start address is: 0 (R0)
; data_ start address is: 4 (R1)
; crc start address is: 8 (R2)
; crc_low start address is: 44 (R11)
; crc_high start address is: 40 (R10)
; poly_low start address is: 24 (R6)
; poly_high start address is: 28 (R7)
; counter start address is: 32 (R8)
CMP	R9, #0
IT	LS
BLS	L_aes132c_calculate_crc4
;aes132_comm.c,43 :: 		data_bit = (data[counter] & shift_register) ? 1 : 0;
ADD	R3, R1, R8, LSL #0
LDRB	R3, [R3, #0]
AND	R3, R3, R9, LSL #0
UXTB	R3, R3
CMP	R3, #0
IT	EQ
BEQ	L_aes132c_calculate_crc6
; ?FLOC___aes132c_calculate_crc?T12 start address is: 48 (R12)
MOVW	R12, #1
SXTB	R12, R12
; ?FLOC___aes132c_calculate_crc?T12 end address is: 48 (R12)
IT	AL
BAL	L_aes132c_calculate_crc7
L_aes132c_calculate_crc6:
; ?FLOC___aes132c_calculate_crc?T12 start address is: 48 (R12)
MOVW	R12, #0
SXTB	R12, R12
; ?FLOC___aes132c_calculate_crc?T12 end address is: 48 (R12)
L_aes132c_calculate_crc7:
;aes132_comm.c,44 :: 		crc_bit = crc_high >> 7;
; ?FLOC___aes132c_calculate_crc?T12 start address is: 48 (R12)
LSR	R5, R10, #7
UXTB	R5, R5
;aes132_comm.c,47 :: 		crc_carry = crc_low >> 7;
LSR	R4, R11, #7
UXTB	R4, R4
;aes132_comm.c,48 :: 		crc_low <<= 1;
LSL	R3, R11, #1
UXTB	R11, R3
;aes132_comm.c,49 :: 		crc_high <<= 1;
LSL	R3, R10, #1
; crc_high end address is: 40 (R10)
;aes132_comm.c,50 :: 		crc_high |= crc_carry;
UXTB	R3, R3
ORRS	R3, R4
; crc_high start address is: 16 (R4)
UXTB	R4, R3
;aes132_comm.c,52 :: 		if ((data_bit ^ crc_bit) != 0) {
UXTB	R3, R12
; ?FLOC___aes132c_calculate_crc?T12 end address is: 48 (R12)
EORS	R3, R5
UXTB	R3, R3
CMP	R3, #0
IT	EQ
BEQ	L__aes132c_calculate_crc69
;aes132_comm.c,53 :: 		crc_low ^= poly_low;
EOR	R3, R11, R6, LSL #0
; crc_low end address is: 44 (R11)
; crc_low start address is: 20 (R5)
UXTB	R5, R3
;aes132_comm.c,54 :: 		crc_high ^= poly_high;
EOR	R10, R4, R7, LSL #0
UXTB	R10, R10
; crc_high end address is: 16 (R4)
; crc_high start address is: 40 (R10)
; crc_low end address is: 20 (R5)
; crc_high end address is: 40 (R10)
UXTB	R11, R5
;aes132_comm.c,55 :: 		}
IT	AL
BAL	L_aes132c_calculate_crc8
L__aes132c_calculate_crc69:
;aes132_comm.c,52 :: 		if ((data_bit ^ crc_bit) != 0) {
UXTB	R10, R4
;aes132_comm.c,55 :: 		}
L_aes132c_calculate_crc8:
;aes132_comm.c,42 :: 		for (shift_register = 0x80; shift_register > 0x00; shift_register >>= 1) {
; crc_high start address is: 40 (R10)
; crc_low start address is: 44 (R11)
LSR	R9, R9, #1
UXTB	R9, R9
;aes132_comm.c,56 :: 		}
; shift_register end address is: 36 (R9)
IT	AL
BAL	L_aes132c_calculate_crc3
L_aes132c_calculate_crc4:
;aes132_comm.c,41 :: 		for (counter = 0; counter < length; counter++) {
ADD	R8, R8, #1
UXTB	R8, R8
;aes132_comm.c,57 :: 		}
; length end address is: 0 (R0)
; data_ end address is: 4 (R1)
; poly_low end address is: 24 (R6)
; poly_high end address is: 28 (R7)
; counter end address is: 32 (R8)
IT	AL
BAL	L_aes132c_calculate_crc0
L_aes132c_calculate_crc1:
;aes132_comm.c,58 :: 		crc[0] = crc_high;
STRB	R10, [R2, #0]
; crc_high end address is: 40 (R10)
;aes132_comm.c,59 :: 		crc[1] = crc_low;
ADDS	R3, R2, #1
; crc end address is: 8 (R2)
STRB	R11, [R3, #0]
; crc_low end address is: 44 (R11)
;aes132_comm.c,60 :: 		}
L_end_aes132c_calculate_crc:
BX	LR
; end of _aes132c_calculate_crc
_aes132c_reset_io_address:
;aes132_comm.c,66 :: 		uint8_t aes132c_reset_io_address(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,68 :: 		return aes132p_write_memory_physical(0, AES132_RESET_ADDR, 0 );
MOVS	R2, #0
MOVW	R1, #65504
MOVS	R0, #0
BL	_aes132p_write_memory_physical+0
;aes132_comm.c,69 :: 		}
L_end_aes132c_reset_io_address:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_reset_io_address
_aes132c_resync:
;aes132_comm.c,75 :: 		uint8_t aes132c_resync()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,77 :: 		uint8_t aes132_lib_return = aes132p_resync_physical();
BL	_aes132p_resync_physical+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,78 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_resync9
;aes132_comm.c,79 :: 		return aes132_lib_return;
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_end_aes132c_resync
L_aes132c_resync9:
;aes132_comm.c,81 :: 		return aes132c_reset_io_address();
BL	_aes132c_reset_io_address+0
;aes132_comm.c,82 :: 		}
L_end_aes132c_resync:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_resync
_aes132c_read_device_status_register:
;aes132_comm.c,89 :: 		uint8_t aes132c_read_device_status_register(uint8_t *device_status_register)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STR	R0, [SP, #8]
;aes132_comm.c,92 :: 		uint8_t n_retries = AES132_RETRY_COUNT_ERROR;
MOVS	R1, #2
STRB	R1, [SP, #4]
;aes132_comm.c,94 :: 		do {
L_aes132c_read_device_status_register10:
;aes132_comm.c,95 :: 		aes132_lib_return = aes132p_read_memory_physical(1, AES132_STATUS_ADDR, device_status_register);
LDR	R2, [SP, #8]
MOVW	R1, #65520
MOVS	R0, #1
BL	_aes132p_read_memory_physical+0
; aes132_lib_return start address is: 8 (R2)
UXTB	R2, R0
;aes132_comm.c,96 :: 		} while ((aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) && (--n_retries > 0));
CMP	R0, #0
IT	EQ
BEQ	L__aes132c_read_device_status_register72
LDRB	R1, [SP, #4]
SUBS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [SP, #4]
CMP	R1, #0
IT	LS
BLS	L__aes132c_read_device_status_register71
IT	AL
BAL	L_aes132c_read_device_status_register10
L__aes132c_read_device_status_register72:
L__aes132c_read_device_status_register71:
;aes132_comm.c,98 :: 		return aes132_lib_return;
UXTB	R0, R2
; aes132_lib_return end address is: 8 (R2)
;aes132_comm.c,99 :: 		}
L_end_aes132c_read_device_status_register:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _aes132c_read_device_status_register
_aes132c_wait_for_status_register_bit:
;aes132_comm.c,109 :: 		uint8_t aes132c_wait_for_status_register_bit(uint8_t mask, uint8_t is_set, uint16_t n_retries)
; n_retries start address is: 8 (R2)
; is_set start address is: 4 (R1)
; mask start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
; n_retries end address is: 8 (R2)
; is_set end address is: 4 (R1)
; mask end address is: 0 (R0)
; mask start address is: 0 (R0)
; is_set start address is: 4 (R1)
; n_retries start address is: 8 (R2)
UXTH	R5, R2
; mask end address is: 0 (R0)
; n_retries end address is: 8 (R2)
UXTB	R2, R0
;aes132_comm.c,114 :: 		do {
IT	AL
BAL	L_aes132c_wait_for_status_register_bit15
L__aes132c_wait_for_status_register_bit73:
;aes132_comm.c,135 :: 		} while (n_retries-- > 0);
;aes132_comm.c,114 :: 		do {
L_aes132c_wait_for_status_register_bit15:
;aes132_comm.c,115 :: 		aes132_lib_return = aes132p_read_memory_physical(1, AES132_STATUS_ADDR, &device_status_register);
; n_retries start address is: 20 (R5)
; mask start address is: 8 (R2)
; is_set start address is: 4 (R1)
; is_set end address is: 4 (R1)
; mask start address is: 8 (R2)
; mask end address is: 8 (R2)
ADD	R3, SP, #16
STRB	R2, [SP, #4]
STRB	R1, [SP, #8]
STRH	R5, [SP, #12]
MOV	R2, R3
MOVW	R1, #65520
MOVS	R0, #1
BL	_aes132p_read_memory_physical+0
LDRH	R5, [SP, #12]
LDRB	R1, [SP, #8]
LDRB	R2, [SP, #4]
; aes132_lib_return start address is: 16 (R4)
UXTB	R4, R0
;aes132_comm.c,116 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_wait_for_status_register_bit18
; is_set end address is: 4 (R1)
; mask end address is: 8 (R2)
; aes132_lib_return end address is: 16 (R4)
;aes132_comm.c,118 :: 		continue;
; mask start address is: 8 (R2)
; is_set start address is: 4 (R1)
IT	AL
BAL	L_aes132c_wait_for_status_register_bit17
L_aes132c_wait_for_status_register_bit18:
;aes132_comm.c,120 :: 		if (is_set == AES132_BIT_SET) {
; aes132_lib_return start address is: 16 (R4)
CMP	R1, #1
IT	NE
BNE	L_aes132c_wait_for_status_register_bit19
;aes132_comm.c,122 :: 		if ((device_status_register & mask) == mask)
LDRB	R3, [SP, #16]
ANDS	R3, R2
UXTB	R3, R3
CMP	R3, R2
IT	NE
BNE	L_aes132c_wait_for_status_register_bit20
; is_set end address is: 4 (R1)
; mask end address is: 8 (R2)
; n_retries end address is: 20 (R5)
;aes132_comm.c,124 :: 		return aes132_lib_return;
UXTB	R0, R4
; aes132_lib_return end address is: 16 (R4)
IT	AL
BAL	L_end_aes132c_wait_for_status_register_bit
L_aes132c_wait_for_status_register_bit20:
;aes132_comm.c,126 :: 		} else {
; n_retries start address is: 20 (R5)
; mask start address is: 8 (R2)
; is_set start address is: 4 (R1)
IT	AL
BAL	L_aes132c_wait_for_status_register_bit21
L_aes132c_wait_for_status_register_bit19:
;aes132_comm.c,128 :: 		if ((device_status_register & mask) == 0)
; aes132_lib_return start address is: 16 (R4)
LDRB	R3, [SP, #16]
ANDS	R3, R2
UXTB	R3, R3
CMP	R3, #0
IT	NE
BNE	L_aes132c_wait_for_status_register_bit22
; is_set end address is: 4 (R1)
; mask end address is: 8 (R2)
; n_retries end address is: 20 (R5)
;aes132_comm.c,130 :: 		return aes132_lib_return;
UXTB	R0, R4
; aes132_lib_return end address is: 16 (R4)
IT	AL
BAL	L_end_aes132c_wait_for_status_register_bit
L_aes132c_wait_for_status_register_bit22:
;aes132_comm.c,131 :: 		}
; n_retries start address is: 20 (R5)
; mask start address is: 8 (R2)
; is_set start address is: 4 (R1)
L_aes132c_wait_for_status_register_bit21:
;aes132_comm.c,135 :: 		} while (n_retries-- > 0);
L_aes132c_wait_for_status_register_bit17:
UXTH	R4, R5
SUBS	R5, R5, #1
UXTH	R5, R5
CMP	R4, #0
IT	HI
BHI	L__aes132c_wait_for_status_register_bit73
; is_set end address is: 4 (R1)
; mask end address is: 8 (R2)
; n_retries end address is: 20 (R5)
;aes132_comm.c,139 :: 		return AES132_FUNCTION_RETCODE_TIMEOUT;
MOVS	R0, #231
;aes132_comm.c,140 :: 		}
L_end_aes132c_wait_for_status_register_bit:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _aes132c_wait_for_status_register_bit
_aes132c_wait_for_device_ready:
;aes132_comm.c,146 :: 		uint8_t aes132c_wait_for_device_ready(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,148 :: 		return aes132c_wait_for_status_register_bit(AES132_WIP_BIT, AES132_BIT_CLEARED, AES132_RETRY_COUNT_DEVICE_READY);
MOVW	R2, #2400
MOVS	R1, #0
MOVS	R0, #1
BL	_aes132c_wait_for_status_register_bit+0
;aes132_comm.c,149 :: 		}
L_end_aes132c_wait_for_device_ready:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_wait_for_device_ready
_aes132c_wait_for_response_ready:
;aes132_comm.c,155 :: 		uint8_t aes132c_wait_for_response_ready(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,157 :: 		return aes132c_wait_for_status_register_bit(AES132_RESPONSE_READY_BIT, AES132_BIT_SET, AES132_RETRY_COUNT_RESPONSE_READY);
MOVW	R2, #1788
MOVS	R1, #1
MOVS	R0, #64
BL	_aes132c_wait_for_status_register_bit+0
;aes132_comm.c,158 :: 		}
L_end_aes132c_wait_for_response_ready:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_wait_for_response_ready
_aes132c_send_sleep_command:
;aes132_comm.c,165 :: 		uint8_t aes132c_send_sleep_command(uint8_t standby)
; standby start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
UXTB	R1, R0
; standby end address is: 0 (R0)
; standby start address is: 4 (R1)
;aes132_comm.c,178 :: 		uint8_t aes132_lib_return = aes132c_reset_io_address();
STRB	R1, [SP, #4]
BL	_aes132c_reset_io_address+0
LDRB	R1, [SP, #4]
; aes132_lib_return start address is: 8 (R2)
UXTB	R2, R0
;aes132_comm.c,179 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_send_sleep_command23
; standby end address is: 4 (R1)
;aes132_comm.c,180 :: 		return aes132_lib_return;
UXTB	R0, R2
; aes132_lib_return end address is: 8 (R2)
IT	AL
BAL	L_end_aes132c_send_sleep_command
L_aes132c_send_sleep_command23:
;aes132_comm.c,182 :: 		if (standby == AES132_COMMAND_MODE_SLEEP)
; standby start address is: 4 (R1)
CMP	R1, #0
IT	NE
BNE	L_aes132c_send_sleep_command24
; standby end address is: 4 (R1)
;aes132_comm.c,183 :: 		return aes132c_send_command((uint8_t *) command_sleep, options);
MOVS	R1, #3
MOVW	R0, #lo_addr(aes132c_send_sleep_command_command_sleep_L0+0)
MOVT	R0, #hi_addr(aes132c_send_sleep_command_command_sleep_L0+0)
BL	_aes132c_send_command+0
IT	AL
BAL	L_end_aes132c_send_sleep_command
L_aes132c_send_sleep_command24:
;aes132_comm.c,185 :: 		return aes132c_send_command((uint8_t *) command_standby, options);
MOVS	R1, #3
MOVW	R0, #lo_addr(aes132c_send_sleep_command_command_standby_L0+0)
MOVT	R0, #hi_addr(aes132c_send_sleep_command_command_standby_L0+0)
BL	_aes132c_send_command+0
;aes132_comm.c,186 :: 		}
L_end_aes132c_send_sleep_command:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _aes132c_send_sleep_command
_aes132c_wakeup:
;aes132_comm.c,195 :: 		uint8_t aes132c_wakeup(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,197 :: 		return aes132c_wait_for_device_ready();
BL	_aes132c_wait_for_device_ready+0
;aes132_comm.c,198 :: 		}
L_end_aes132c_wakeup:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_wakeup
_aes132c_sleep:
;aes132_comm.c,204 :: 		uint8_t aes132c_sleep(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,206 :: 		return aes132c_send_sleep_command(AES132_COMMAND_MODE_SLEEP);
MOVS	R0, #0
BL	_aes132c_send_sleep_command+0
;aes132_comm.c,207 :: 		}
L_end_aes132c_sleep:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_sleep
_aes132c_standby:
;aes132_comm.c,213 :: 		uint8_t aes132c_standby(void)
SUB	SP, SP, #4
STR	LR, [SP, #0]
;aes132_comm.c,215 :: 		return aes132c_send_sleep_command(AES132_COMMAND_MODE_STANDBY);
MOVS	R0, #64
BL	_aes132c_send_sleep_command+0
;aes132_comm.c,216 :: 		}
L_end_aes132c_standby:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _aes132c_standby
_aes132c_access_memory:
;aes132_comm.c,226 :: 		uint8_t aes132c_access_memory(uint8_t count, uint16_t word_address, uint8_t *data, uint8_t read)
SUB	SP, SP, #32
STR	LR, [SP, #0]
STRB	R0, [SP, #16]
STRH	R1, [SP, #20]
STR	R2, [SP, #24]
STRB	R3, [SP, #28]
;aes132_comm.c,234 :: 		uint8_t n_retries_resync = AES132_RETRY_COUNT_RESYNC;
MOVS	R4, #2
STRB	R4, [SP, #13]
;aes132_comm.c,239 :: 		do {
L_aes132c_access_memory25:
;aes132_comm.c,240 :: 		n_retries_memory_access = AES132_RETRY_COUNT_ERROR;
MOVS	R4, #2
STRB	R4, [SP, #8]
;aes132_comm.c,242 :: 		do {
L_aes132c_access_memory28:
;aes132_comm.c,243 :: 		aes132_lib_return = aes132c_wait_for_device_ready();
BL	_aes132c_wait_for_device_ready+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,244 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_access_memory31
;aes132_comm.c,246 :: 		break;
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_aes132c_access_memory29
L_aes132c_access_memory31:
;aes132_comm.c,248 :: 		if (read == 0) {
LDRB	R4, [SP, #28]
CMP	R4, #0
IT	NE
BNE	L_aes132c_access_memory32
;aes132_comm.c,250 :: 		aes132_lib_return = aes132p_write_memory_physical(count, word_address, data);
LDR	R2, [SP, #24]
LDRH	R1, [SP, #20]
LDRB	R0, [SP, #16]
BL	_aes132p_write_memory_physical+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,251 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_access_memory33
;aes132_comm.c,253 :: 		continue;
UXTB	R0, R1
IT	AL
BAL	L_aes132c_access_memory30
L_aes132c_access_memory33:
;aes132_comm.c,256 :: 		if        (word_address >= AES132_IO_ADDR)
LDRH	R4, [SP, #20]
CMP	R4, #65024
IT	CC
BCC	L_aes132c_access_memory34
;aes132_comm.c,259 :: 		return aes132_lib_return;
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_end_aes132c_access_memory
L_aes132c_access_memory34:
;aes132_comm.c,262 :: 		aes132c_wait_for_response_ready();
BL	_aes132c_wait_for_response_ready+0
;aes132_comm.c,264 :: 		aes132_lib_return = aes132c_receive_response(AES132_RESPONSE_SIZE_MAX, response_buffer);
ADD	R4, SP, #9
MOV	R1, R4
MOVS	R0, #52
BL	_aes132c_receive_response+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,265 :: 		if (aes132_lib_return == AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	NE
BNE	L_aes132c_access_memory35
; aes132_lib_return end address is: 4 (R1)
;aes132_comm.c,267 :: 		return response_buffer[AES132_RESPONSE_INDEX_RETURN_CODE];
ADD	R4, SP, #9
ADDS	R4, R4, #1
LDRB	R4, [R4, #0]
UXTB	R0, R4
IT	AL
BAL	L_end_aes132c_access_memory
L_aes132c_access_memory35:
;aes132_comm.c,271 :: 		return aes132_lib_return;
; aes132_lib_return start address is: 4 (R1)
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_end_aes132c_access_memory
;aes132_comm.c,272 :: 		}
L_aes132c_access_memory32:
;aes132_comm.c,275 :: 		aes132_lib_return = aes132p_read_memory_physical(count, word_address, data);
LDR	R2, [SP, #24]
LDRH	R1, [SP, #20]
LDRB	R0, [SP, #16]
BL	_aes132p_read_memory_physical+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,276 :: 		if (aes132_lib_return == AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	NE
BNE	L_aes132c_access_memory38
;aes132_comm.c,277 :: 		return aes132_lib_return;
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_end_aes132c_access_memory
L_aes132c_access_memory38:
;aes132_comm.c,280 :: 		} while (--n_retries_memory_access > 0);
; aes132_lib_return start address is: 4 (R1)
UXTB	R0, R1
L_aes132c_access_memory30:
; aes132_lib_return end address is: 4 (R1)
; aes132_lib_return start address is: 0 (R0)
LDRB	R4, [SP, #8]
SUBS	R4, R4, #1
UXTB	R4, R4
STRB	R4, [SP, #8]
CMP	R4, #0
IT	HI
BHI	L_aes132c_access_memory28
; aes132_lib_return end address is: 0 (R0)
L_aes132c_access_memory29:
;aes132_comm.c,283 :: 		if (--n_retries_resync == 0)
; aes132_lib_return start address is: 0 (R0)
LDRB	R4, [SP, #13]
SUBS	R4, R4, #1
UXTB	R4, R4
STRB	R4, [SP, #13]
CMP	R4, #0
IT	NE
BNE	L_aes132c_access_memory39
;aes132_comm.c,285 :: 		return aes132_lib_return;
; aes132_lib_return end address is: 0 (R0)
IT	AL
BAL	L_end_aes132c_access_memory
L_aes132c_access_memory39:
;aes132_comm.c,289 :: 		(void) aes132c_resync();
; aes132_lib_return start address is: 0 (R0)
STRB	R0, [SP, #4]
BL	_aes132c_resync+0
LDRB	R0, [SP, #4]
;aes132_comm.c,292 :: 		} while (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS);
CMP	R0, #0
IT	NE
BNE	L_aes132c_access_memory25
;aes132_comm.c,294 :: 		return aes132_lib_return;
; aes132_lib_return end address is: 0 (R0)
;aes132_comm.c,295 :: 		}
L_end_aes132c_access_memory:
LDR	LR, [SP, #0]
ADD	SP, SP, #32
BX	LR
; end of _aes132c_access_memory
_aes132c_send_command:
;aes132_comm.c,311 :: 		uint8_t aes132c_send_command(uint8_t *command, uint8_t options)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R0, [SP, #8]
STRB	R1, [SP, #12]
;aes132_comm.c,314 :: 		uint8_t n_retries = AES132_RETRY_COUNT_ERROR;
MOVS	R2, #2
STRB	R2, [SP, #7]
;aes132_comm.c,316 :: 		uint8_t count = command[AES132_COMMAND_INDEX_COUNT];
LDR	R2, [SP, #8]
LDRB	R2, [R2, #0]
STRB	R2, [SP, #6]
;aes132_comm.c,318 :: 		if ((options & AES132_OPTION_NO_APPEND_CRC) == 0)
LDRB	R2, [SP, #12]
AND	R2, R2, #1
UXTB	R2, R2
CMP	R2, #0
IT	NE
BNE	L_aes132c_send_command40
;aes132_comm.c,320 :: 		aes132c_calculate_crc(count - AES132_CRC_SIZE, command, &command[count - AES132_CRC_SIZE]);
LDRB	R2, [SP, #6]
SUBS	R3, R2, #2
SXTH	R3, R3
LDR	R2, [SP, #8]
ADDS	R3, R2, R3
LDRB	R2, [SP, #6]
SUBS	R2, R2, #2
LDR	R1, [SP, #8]
UXTB	R0, R2
MOV	R2, R3
BL	_aes132c_calculate_crc+0
L_aes132c_send_command40:
;aes132_comm.c,322 :: 		do {
L_aes132c_send_command41:
;aes132_comm.c,323 :: 		aes132_lib_return = aes132c_access_memory(count, AES132_IO_ADDR, command,  AES132_WRITE);
MOVS	R3, #0
LDR	R2, [SP, #8]
MOVW	R1, #65024
LDRB	R0, [SP, #6]
BL	_aes132c_access_memory+0
STRB	R0, [SP, #4]
;aes132_comm.c,324 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_send_command44
;aes132_comm.c,326 :: 		continue;
IT	AL
BAL	L_aes132c_send_command43
L_aes132c_send_command44:
;aes132_comm.c,328 :: 		if ((options & AES132_OPTION_NO_STATUS_READ) != 0)
LDRB	R2, [SP, #12]
AND	R2, R2, #2
UXTB	R2, R2
CMP	R2, #0
IT	EQ
BEQ	L_aes132c_send_command45
;aes132_comm.c,330 :: 		return aes132_lib_return;
LDRB	R0, [SP, #4]
IT	AL
BAL	L_end_aes132c_send_command
L_aes132c_send_command45:
;aes132_comm.c,334 :: 		aes132_lib_return = aes132c_read_device_status_register(&device_status_register);
ADD	R2, SP, #5
MOV	R0, R2
BL	_aes132c_read_device_status_register+0
STRB	R0, [SP, #4]
;aes132_comm.c,336 :: 		if (aes132_lib_return == AES132_FUNCTION_RETCODE_SUCCESS) {
CMP	R0, #0
IT	NE
BNE	L_aes132c_send_command46
;aes132_comm.c,338 :: 		if ((device_status_register & AES132_CRC_ERROR_BIT) != 0)
LDRB	R2, [SP, #5]
AND	R2, R2, #16
UXTB	R2, R2
CMP	R2, #0
IT	EQ
BEQ	L_aes132c_send_command47
;aes132_comm.c,341 :: 		aes132_lib_return = AES132_FUNCTION_RETCODE_BAD_CRC_TX;
MOVS	R2, #212
STRB	R2, [SP, #4]
L_aes132c_send_command47:
;aes132_comm.c,342 :: 		}
IT	AL
BAL	L_aes132c_send_command48
L_aes132c_send_command46:
;aes132_comm.c,343 :: 		else if (aes132_lib_return == AES132_FUNCTION_RETCODE_COMM_FAIL){
LDRB	R2, [SP, #4]
CMP	R2, #240
IT	NE
BNE	L_aes132c_send_command49
;aes132_comm.c,346 :: 		return AES132_FUNCTION_RETCODE_SUCCESS;
MOVS	R0, #0
IT	AL
BAL	L_end_aes132c_send_command
;aes132_comm.c,350 :: 		}else {
L_aes132c_send_command49:
;aes132_comm.c,352 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,353 :: 		return aes132_lib_return;
LDRB	R0, [SP, #4]
IT	AL
BAL	L_end_aes132c_send_command
;aes132_comm.c,354 :: 		}
L_aes132c_send_command48:
;aes132_comm.c,358 :: 		} while ((aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) && (--n_retries > 0));
L_aes132c_send_command43:
LDRB	R2, [SP, #4]
CMP	R2, #0
IT	EQ
BEQ	L__aes132c_send_command85
LDRB	R2, [SP, #7]
SUBS	R2, R2, #1
UXTB	R2, R2
STRB	R2, [SP, #7]
CMP	R2, #0
IT	LS
BLS	L__aes132c_send_command84
IT	AL
BAL	L_aes132c_send_command41
L__aes132c_send_command85:
L__aes132c_send_command84:
;aes132_comm.c,362 :: 		return aes132_lib_return;
LDRB	R0, [SP, #4]
;aes132_comm.c,363 :: 		}
L_end_aes132c_send_command:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _aes132c_send_command
_aes132c_receive_response:
;aes132_comm.c,371 :: 		uint8_t aes132c_receive_response(uint8_t size, uint8_t *response)
SUB	SP, SP, #20
STR	LR, [SP, #0]
STRB	R0, [SP, #12]
STR	R1, [SP, #16]
;aes132_comm.c,374 :: 		uint8_t n_retries = AES132_RETRY_COUNT_ERROR;
MOVS	R2, #2
STRB	R2, [SP, #9]
;aes132_comm.c,379 :: 		do {
L_aes132c_receive_response53:
;aes132_comm.c,380 :: 		aes132_lib_return = aes132c_wait_for_response_ready();
BL	_aes132c_wait_for_response_ready+0
STRB	R0, [SP, #4]
;aes132_comm.c,381 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) {
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_receive_response56
;aes132_comm.c,385 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,386 :: 		continue;
IT	AL
BAL	L_aes132c_receive_response55
;aes132_comm.c,387 :: 		}
L_aes132c_receive_response56:
;aes132_comm.c,390 :: 		aes132_lib_return = aes132p_read_memory_physical(1, AES132_IO_ADDR, &response[AES132_COMMAND_INDEX_COUNT]);
LDR	R2, [SP, #16]
MOVW	R1, #65024
MOVS	R0, #1
BL	_aes132p_read_memory_physical+0
STRB	R0, [SP, #4]
;aes132_comm.c,391 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) {
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_receive_response57
;aes132_comm.c,395 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,396 :: 		continue;
IT	AL
BAL	L_aes132c_receive_response55
;aes132_comm.c,397 :: 		}
L_aes132c_receive_response57:
;aes132_comm.c,399 :: 		count_byte = response[AES132_RESPONSE_INDEX_COUNT];
LDR	R2, [SP, #16]
LDRB	R3, [R2, #0]
STRB	R3, [SP, #8]
;aes132_comm.c,400 :: 		if (count_byte > size) {
LDRB	R2, [SP, #12]
CMP	R3, R2
IT	LS
BLS	L_aes132c_receive_response58
;aes132_comm.c,404 :: 		aes132_lib_return = AES132_FUNCTION_RETCODE_SIZE_TOO_SMALL;
MOVS	R2, #162
STRB	R2, [SP, #4]
;aes132_comm.c,406 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,407 :: 		continue;
IT	AL
BAL	L_aes132c_receive_response55
;aes132_comm.c,408 :: 		}
L_aes132c_receive_response58:
;aes132_comm.c,410 :: 		if ((count_byte < AES132_RESPONSE_SIZE_MIN) || (count_byte > AES132_RESPONSE_SIZE_MAX)) {
LDRB	R2, [SP, #8]
CMP	R2, #4
IT	CC
BCC	L__aes132c_receive_response78
LDRB	R2, [SP, #8]
CMP	R2, #52
IT	HI
BHI	L__aes132c_receive_response77
IT	AL
BAL	L_aes132c_receive_response61
L__aes132c_receive_response78:
L__aes132c_receive_response77:
;aes132_comm.c,413 :: 		aes132_lib_return = AES132_FUNCTION_RETCODE_COUNT_INVALID;
MOVS	R2, #228
STRB	R2, [SP, #4]
;aes132_comm.c,415 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,416 :: 		continue;
IT	AL
BAL	L_aes132c_receive_response55
;aes132_comm.c,417 :: 		}
L_aes132c_receive_response61:
;aes132_comm.c,420 :: 		aes132_lib_return = aes132p_read_memory_physical(count_byte - 1, AES132_IO_ADDR, &response[AES132_RESPONSE_INDEX_RETURN_CODE]);
LDR	R2, [SP, #16]
ADDS	R3, R2, #1
LDRB	R2, [SP, #8]
SUBS	R2, R2, #1
MOVW	R1, #65024
UXTB	R0, R2
MOV	R2, R3
BL	_aes132p_read_memory_physical+0
STRB	R0, [SP, #4]
;aes132_comm.c,421 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) {
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_receive_response62
;aes132_comm.c,425 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,426 :: 		continue;
IT	AL
BAL	L_aes132c_receive_response55
;aes132_comm.c,427 :: 		}
L_aes132c_receive_response62:
;aes132_comm.c,430 :: 		crc_index = count_byte - AES132_CRC_SIZE;
LDRB	R2, [SP, #8]
SUBS	R3, R2, #2
STRB	R3, [SP, #7]
;aes132_comm.c,431 :: 		aes132c_calculate_crc(crc_index, response, crc);
ADD	R2, SP, #5
LDR	R1, [SP, #16]
UXTB	R0, R3
BL	_aes132c_calculate_crc+0
;aes132_comm.c,432 :: 		if ((crc[0] == response[crc_index]) && (crc[1] == response[crc_index + 1]))
ADD	R2, SP, #5
LDRB	R4, [R2, #0]
LDRB	R3, [SP, #7]
LDR	R2, [SP, #16]
ADDS	R2, R2, R3
LDRB	R2, [R2, #0]
CMP	R4, R2
IT	NE
BNE	L__aes132c_receive_response80
ADD	R2, SP, #5
ADDS	R2, R2, #1
LDRB	R4, [R2, #0]
LDRB	R2, [SP, #7]
ADDS	R3, R2, #1
SXTH	R3, R3
LDR	R2, [SP, #16]
ADDS	R2, R2, R3
LDRB	R2, [R2, #0]
CMP	R4, R2
IT	NE
BNE	L__aes132c_receive_response79
L__aes132c_receive_response75:
;aes132_comm.c,434 :: 		return response[AES132_RESPONSE_INDEX_RETURN_CODE];
LDR	R2, [SP, #16]
ADDS	R2, R2, #1
LDRB	R2, [R2, #0]
UXTB	R0, R2
IT	AL
BAL	L_end_aes132c_receive_response
;aes132_comm.c,432 :: 		if ((crc[0] == response[crc_index]) && (crc[1] == response[crc_index + 1]))
L__aes132c_receive_response80:
L__aes132c_receive_response79:
;aes132_comm.c,437 :: 		aes132_lib_return = AES132_FUNCTION_RETCODE_BAD_CRC_RX;
MOVS	R2, #229
STRB	R2, [SP, #4]
;aes132_comm.c,440 :: 		(void) aes132c_resync();
BL	_aes132c_resync+0
;aes132_comm.c,443 :: 		} while ((aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS) && (--n_retries > 0));
L_aes132c_receive_response55:
LDRB	R2, [SP, #4]
CMP	R2, #0
IT	EQ
BEQ	L__aes132c_receive_response82
LDRB	R2, [SP, #9]
SUBS	R2, R2, #1
UXTB	R2, R2
STRB	R2, [SP, #9]
CMP	R2, #0
IT	LS
BLS	L__aes132c_receive_response81
IT	AL
BAL	L_aes132c_receive_response53
L__aes132c_receive_response82:
L__aes132c_receive_response81:
;aes132_comm.c,446 :: 		return aes132_lib_return;
LDRB	R0, [SP, #4]
;aes132_comm.c,447 :: 		}
L_end_aes132c_receive_response:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _aes132c_receive_response
_aes132c_send_and_receive:
;aes132_comm.c,457 :: 		uint8_t aes132c_send_and_receive(uint8_t *command, uint8_t size, uint8_t *response, uint8_t options)
; options start address is: 12 (R3)
; command start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRB	R1, [SP, #4]
STR	R2, [SP, #8]
; options end address is: 12 (R3)
; command end address is: 0 (R0)
; command start address is: 0 (R0)
; options start address is: 12 (R3)
;aes132_comm.c,459 :: 		uint8_t aes132_lib_return = aes132c_send_command(command, options);
UXTB	R1, R3
; options end address is: 12 (R3)
; command end address is: 0 (R0)
BL	_aes132c_send_command+0
; aes132_lib_return start address is: 4 (R1)
UXTB	R1, R0
;aes132_comm.c,460 :: 		if (aes132_lib_return != AES132_FUNCTION_RETCODE_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_aes132c_send_and_receive68
;aes132_comm.c,461 :: 		return aes132_lib_return;
UXTB	R0, R1
; aes132_lib_return end address is: 4 (R1)
IT	AL
BAL	L_end_aes132c_send_and_receive
L_aes132c_send_and_receive68:
;aes132_comm.c,463 :: 		return aes132c_receive_response(size, response);
LDR	R1, [SP, #8]
LDRB	R0, [SP, #4]
BL	_aes132c_receive_response+0
;aes132_comm.c,464 :: 		}
L_end_aes132c_send_and_receive:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _aes132c_send_and_receive
