#line 1 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_comm.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_i2c.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/__secure2_hal.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 120 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/__secure2_hal.h"
typedef void ( *T_SECURE2_I2C_Start )( char slave_address,
 char dir);
typedef void ( *T_SECURE2_I2C_Stop )();
typedef void ( *T_SECURE2_I2C_Restart )();
typedef unsigned char ( *T_SECURE2_I2C_Write )( unsigned char data_in,
 unsigned char mode);
typedef unsigned char ( *T_SECURE2_I2C_Read )( unsigned char *data_out,
 unsigned char mode);
#line 135 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_i2c.h"
void aes132p_enable_interface(void);
void aes132p_disable_interface(void);
uint8_t aes132p_select_device(uint8_t device_id);
uint8_t aes132p_read_memory_physical(uint8_t size, uint16_t word_address, uint8_t * data_ );
uint8_t aes132p_write_memory_physical(uint8_t count, uint16_t word_address, uint8_t * data_ );
uint8_t aes132p_resync_physical(void);
#line 32 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_comm.h"
enum aes132_read_write_flag {
 AES132_WRITE = (uint8_t) 0,
 AES132_READ = (uint8_t) 1
};
#line 40 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_comm.h"
enum aes132_bit_set_flag {
 AES132_BIT_CLEARED = (uint8_t) 0,
 AES132_BIT_SET = (uint8_t) 1
};
#line 237 "c:/users/djordje.rosic/desktop/c/arm/tiva/library/aes132_comm.h"
uint8_t aes132c_access_memory(uint8_t count, uint16_t word_address, uint8_t * data_ , uint8_t read);
uint8_t aes132c_read_device_status_register(uint8_t *deviceStatus);
uint8_t aes132c_send_command(uint8_t *command, uint8_t options);
uint8_t aes132c_receive_response(uint8_t count, uint8_t *response);
uint8_t aes132c_send_and_receive(uint8_t *command, uint8_t size, uint8_t *response, uint8_t options);
uint8_t aes132c_wakeup(void);
uint8_t aes132c_sleep(void);
uint8_t aes132c_standby(void);
uint8_t aes132c_resync(void);
uint8_t aes132c_wait_for_status_register_bit(uint8_t mask, uint8_t is_set, uint16_t n_retries);
uint8_t aes132c_wait_for_response_ready(void);
uint8_t aes132c_wait_for_device_ready(void);
uint8_t aes132c_send_sleep_command(uint8_t standby);
uint8_t aes132c_reset_io_address(void);
void aes132c_calculate_crc(uint8_t count, uint8_t * data_ , uint8_t *crc);
#line 33 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
void aes132c_calculate_crc(uint8_t length, uint8_t * data_ , uint8_t *crc)
{
 uint8_t counter;
 uint8_t crc_low = 0, crc_high = 0, crc_carry;
 uint8_t poly_low = 0x05, poly_high = 0x80;
 uint8_t shift_register;
 uint8_t data_bit, crc_bit;

 for (counter = 0; counter < length; counter++) {
 for (shift_register = 0x80; shift_register > 0x00; shift_register >>= 1) {
 data_bit = ( data_ [counter] & shift_register) ? 1 : 0;
 crc_bit = crc_high >> 7;


 crc_carry = crc_low >> 7;
 crc_low <<= 1;
 crc_high <<= 1;
 crc_high |= crc_carry;

 if ((data_bit ^ crc_bit) != 0) {
 crc_low ^= poly_low;
 crc_high ^= poly_high;
 }
 }
 }
 crc[0] = crc_high;
 crc[1] = crc_low;
}
#line 66 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_reset_io_address(void)
{
 return aes132p_write_memory_physical(0,  ((uint16_t) 0xFFE0) , 0 );
}
#line 75 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_resync()
{
 uint8_t aes132_lib_return = aes132p_resync_physical();
 if (aes132_lib_return !=  ((uint8_t) 0x00) )
 return aes132_lib_return;

 return aes132c_reset_io_address();
}
#line 89 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_read_device_status_register(uint8_t *device_status_register)
{
 uint8_t aes132_lib_return;
 uint8_t n_retries =  ((uint8_t) 2) ;

 do {
 aes132_lib_return = aes132p_read_memory_physical(1,  ((uint16_t) 0xFFF0) , device_status_register);
 } while ((aes132_lib_return !=  ((uint8_t) 0x00) ) && (--n_retries > 0));

 return aes132_lib_return;
}
#line 109 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_wait_for_status_register_bit(uint8_t mask, uint8_t is_set, uint16_t n_retries)
{
 uint8_t aes132_lib_return;
 uint8_t device_status_register;

 do {
 aes132_lib_return = aes132p_read_memory_physical(1,  ((uint16_t) 0xFFF0) , &device_status_register);
 if (aes132_lib_return !=  ((uint8_t) 0x00) )

 continue;

 if (is_set == AES132_BIT_SET) {

 if ((device_status_register & mask) == mask)

 return aes132_lib_return;

 } else {

 if ((device_status_register & mask) == 0)

 return aes132_lib_return;
 }



 } while (n_retries-- > 0);



 return  ((uint8_t) 0xE7) ;
}
#line 146 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_wait_for_device_ready(void)
{
 return aes132c_wait_for_status_register_bit( ((uint8_t) 0x01) , AES132_BIT_CLEARED,  ((uint16_t) ( (100)  * (1000 / (41) ) )) );
}
#line 155 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_wait_for_response_ready(void)
{
 return aes132c_wait_for_status_register_bit( ((uint8_t) 0x40) , AES132_BIT_SET,  ((uint16_t) ( (145)  * (1000 / (158) )  * 2 + 2 * (1000 / (41) ) )) );
}
#line 165 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_send_sleep_command(uint8_t standby)
{


 const uint8_t command_sleep[] = { ((uint8_t) 9) , 0x11,  ((uint8_t) 0x00) , 0, 0, 0, 0, 0x71, 0x81};
 const uint8_t command_standby[] = { ((uint8_t) 9) , 0x11,  ((uint8_t) 0x40) , 0, 0, 0, 0, 0xEF, 0x82};


 const uint8_t options = ( ((uint8_t) 0x01)  |  ((uint8_t) 0x02) );




 uint8_t aes132_lib_return = aes132c_reset_io_address();
 if (aes132_lib_return !=  ((uint8_t) 0x00) )
 return aes132_lib_return;

 if (standby ==  ((uint8_t) 0x00) )
 return aes132c_send_command((uint8_t *) command_sleep, options);

 return aes132c_send_command((uint8_t *) command_standby, options);
}
#line 195 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_wakeup(void)
{
 return aes132c_wait_for_device_ready();
}
#line 204 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_sleep(void)
{
 return aes132c_send_sleep_command( ((uint8_t) 0x00) );
}
#line 213 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_standby(void)
{
 return aes132c_send_sleep_command( ((uint8_t) 0x40) );
}
#line 226 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_access_memory(uint8_t count, uint16_t word_address, uint8_t * data_ , uint8_t read)
{
 uint8_t aes132_lib_return;


 uint8_t n_retries_memory_access;


 uint8_t n_retries_resync =  ((uint8_t) 2) ;


 uint8_t response_buffer[ ((uint8_t) 4) ];

 do {
 n_retries_memory_access =  ((uint8_t) 2) ;

 do {
 aes132_lib_return = aes132c_wait_for_device_ready();
 if (aes132_lib_return !=  ((uint8_t) 0x00) )

 break;

 if (read == 0) {

 aes132_lib_return = aes132p_write_memory_physical(count, word_address,  data_ );
 if (aes132_lib_return !=  ((uint8_t) 0x00) )

 continue;


 if (word_address >=  ((uint16_t) 0xFE00) )


 return aes132_lib_return;


 aes132c_wait_for_response_ready();

 aes132_lib_return = aes132c_receive_response( ((uint8_t) 52) , response_buffer);
 if (aes132_lib_return ==  ((uint8_t) 0x00) )

 return response_buffer[ ((uint8_t) 1) ];
 else


 return aes132_lib_return;
 }
 else {

 aes132_lib_return = aes132p_read_memory_physical(count, word_address,  data_ );
 if (aes132_lib_return ==  ((uint8_t) 0x00) )
 return aes132_lib_return;
 }

 } while (--n_retries_memory_access > 0);


 if (--n_retries_resync == 0)

 return aes132_lib_return;



 (void) aes132c_resync();


 } while (aes132_lib_return !=  ((uint8_t) 0x00) );

 return aes132_lib_return;
}
#line 311 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_send_command(uint8_t *command, uint8_t options)
{
 uint8_t aes132_lib_return;
 uint8_t n_retries =  ((uint8_t) 2) ;
 uint8_t device_status_register;
 uint8_t count = command[ (0) ];

 if ((options &  ((uint8_t) 0x01) ) == 0)

 aes132c_calculate_crc(count -  ((uint8_t) 2) , command, &command[count -  ((uint8_t) 2) ]);

 do {
 aes132_lib_return = aes132c_access_memory(count,  ((uint16_t) 0xFE00) , command, AES132_WRITE);
 if (aes132_lib_return !=  ((uint8_t) 0x00) )

 continue;

 if ((options &  ((uint8_t) 0x02) ) != 0)

 return aes132_lib_return;



 aes132_lib_return = aes132c_read_device_status_register(&device_status_register);

 if (aes132_lib_return ==  ((uint8_t) 0x00) ) {

 if ((device_status_register &  ((uint8_t) 0x10) ) != 0)


 aes132_lib_return =  ((uint8_t) 0xD4) ;
 }
 else if (aes132_lib_return ==  ((uint8_t) 0xF0) ){


 return  ((uint8_t) 0x00) ;



 }else {

 (void) aes132c_resync();
 return aes132_lib_return;
 }



 } while ((aes132_lib_return !=  ((uint8_t) 0x00) ) && (--n_retries > 0));



 return aes132_lib_return;
}
#line 371 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_receive_response(uint8_t size, uint8_t *response)
{
 uint8_t aes132_lib_return;
 uint8_t n_retries =  ((uint8_t) 2) ;
 uint8_t crc[ ((uint8_t) 2) ];
 uint8_t crc_index;
 uint8_t count_byte;

 do {
 aes132_lib_return = aes132c_wait_for_response_ready();
 if (aes132_lib_return !=  ((uint8_t) 0x00) ) {



 (void) aes132c_resync();
 continue;
 }


 aes132_lib_return = aes132p_read_memory_physical(1,  ((uint16_t) 0xFE00) , &response[ (0) ]);
 if (aes132_lib_return !=  ((uint8_t) 0x00) ) {



 (void) aes132c_resync();
 continue;
 }

 count_byte = response[ ((uint8_t) 0) ];
 if (count_byte > size) {



 aes132_lib_return =  ((uint8_t) 0xA2) ;

 (void) aes132c_resync();
 continue;
 }

 if ((count_byte <  ((uint8_t) 4) ) || (count_byte >  ((uint8_t) 52) )) {


 aes132_lib_return =  ((uint8_t) 0xE4) ;

 (void) aes132c_resync();
 continue;
 }


 aes132_lib_return = aes132p_read_memory_physical(count_byte - 1,  ((uint16_t) 0xFE00) , &response[ ((uint8_t) 1) ]);
 if (aes132_lib_return !=  ((uint8_t) 0x00) ) {



 (void) aes132c_resync();
 continue;
 }


 crc_index = count_byte -  ((uint8_t) 2) ;
 aes132c_calculate_crc(crc_index, response, crc);
 if ((crc[0] == response[crc_index]) && (crc[1] == response[crc_index + 1]))

 return response[ ((uint8_t) 1) ];


 aes132_lib_return =  ((uint8_t) 0xE5) ;


 (void) aes132c_resync();


 } while ((aes132_lib_return !=  ((uint8_t) 0x00) ) && (--n_retries > 0));


 return aes132_lib_return;
}
#line 457 "C:/Users/djordje.rosic/Desktop/c/ARM/TIVA/library/aes132_comm.c"
uint8_t aes132c_send_and_receive(uint8_t *command, uint8_t size, uint8_t *response, uint8_t options)
{
 uint8_t aes132_lib_return = aes132c_send_command(command, options);
 if (aes132_lib_return !=  ((uint8_t) 0x00) )
 return aes132_lib_return;

 return aes132c_receive_response(size, response);
}
